burnin: Add unittest for supported disk templates
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
27 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
28 CHECK_VERSION = $(top_srcdir)/autotools/check-version
29 CHECK_NEWS = $(top_srcdir)/autotools/check-news
30 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
31 DOCPP = $(top_srcdir)/autotools/docpp
32 REPLACE_VARS_SED = autotools/replace_vars.sed
33 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
34 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
35 SHELL_ENV_INIT = autotools/shell-env-init
36
37 # Note: these are automake-specific variables, and must be named after
38 # the directory + 'dir' suffix
39 clientdir = $(pkgpythondir)/client
40 hypervisordir = $(pkgpythondir)/hypervisor
41 httpdir = $(pkgpythondir)/http
42 masterddir = $(pkgpythondir)/masterd
43 confddir = $(pkgpythondir)/confd
44 rapidir = $(pkgpythondir)/rapi
45 serverdir = $(pkgpythondir)/server
46 watcherdir = $(pkgpythondir)/watcher
47 impexpddir = $(pkgpythondir)/impexpd
48 utilsdir = $(pkgpythondir)/utils
49 toolsdir = $(pkglibdir)/tools
50 iallocatorsdir = $(pkglibdir)/iallocators
51 pytoolsdir = $(pkgpythondir)/tools
52 docdir = $(datadir)/doc/$(PACKAGE)
53 myexeclibdir = $(pkglibdir)
54
55 # Delete output file if an error occurred while building it
56 .DELETE_ON_ERROR:
57
58 HS_DIRS = \
59         src \
60         src/Ganeti \
61         src/Ganeti/Block \
62         src/Ganeti/Block/Drbd \
63         src/Ganeti/Confd \
64         src/Ganeti/DataCollectors \
65         src/Ganeti/HTools \
66         src/Ganeti/HTools/Backend \
67         src/Ganeti/HTools/Program \
68         src/Ganeti/Query \
69         test/hs \
70         test/hs/Test \
71         test/hs/Test/Ganeti \
72         test/hs/Test/Ganeti/Block \
73         test/hs/Test/Ganeti/Block/Drbd \
74         test/hs/Test/Ganeti/Confd \
75         test/hs/Test/Ganeti/HTools \
76         test/hs/Test/Ganeti/HTools/Backend \
77         test/hs/Test/Ganeti/Query
78
79 DIRS = \
80         $(HS_DIRS) \
81         autotools \
82         daemons \
83         devel \
84         doc \
85         doc/css \
86         doc/examples \
87         doc/examples/gnt-debug \
88         doc/examples/hooks \
89         test/data/htools \
90         test/data/htools/rapi \
91         test/hs/shelltests \
92         lib \
93         lib/build \
94         lib/client \
95         lib/confd \
96         lib/http \
97         lib/hypervisor \
98         lib/impexpd \
99         lib/masterd \
100         lib/rapi \
101         lib/server \
102         lib/tools \
103         lib/utils \
104         lib/watcher \
105         man \
106         qa \
107         test \
108         test/data \
109         test/data/ovfdata \
110         test/data/ovfdata/other \
111         test/py \
112         tools
113
114 ALL_APIDOC_HS_DIRS = \
115         $(APIDOC_HS_DIR) \
116         $(APIDOC_HS_DIR)/Ganeti \
117         $(APIDOC_HS_DIR)/Ganeti/Block \
118         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
119         $(APIDOC_HS_DIR)/Ganeti/Confd \
120         $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
121         $(APIDOC_HS_DIR)/Ganeti/HTools \
122         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
123         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
124         $(APIDOC_HS_DIR)/Ganeti/Query
125
126 BUILDTIME_DIR_AUTOCREATE = \
127         scripts \
128         $(APIDOC_DIR) \
129         $(ALL_APIDOC_HS_DIRS) \
130         $(APIDOC_PY_DIR) \
131         $(COVERAGE_DIR) \
132         $(COVERAGE_HS_DIR) \
133         $(COVERAGE_PY_DIR) \
134         .hpc
135
136 BUILDTIME_DIRS = \
137         $(BUILDTIME_DIR_AUTOCREATE) \
138         doc/html \
139         doc/man-html
140
141 DIRCHECK_EXCLUDE = \
142         $(BUILDTIME_DIRS) \
143         ganeti-[0-9]*.[0-9]*.[0-9]* \
144         doc/html/_* \
145         doc/man-html/_* \
146         autom4te.cache
147
148 # some helper vars
149 COVERAGE_DIR = doc/coverage
150 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
151 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
152 APIDOC_DIR = doc/api
153 APIDOC_PY_DIR = $(APIDOC_DIR)/py
154 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
155
156 MAINTAINERCLEANFILES = \
157         $(maninput) \
158         doc/install-quick.rst \
159         doc/news.rst \
160         doc/upgrade.rst \
161         vcs-version
162
163 maintainer-clean-local:
164         rm -rf $(BUILDTIME_DIRS)
165
166 CLEANFILES = \
167         $(addsuffix /*.py[co],$(DIRS)) \
168         $(addsuffix /*.hi,$(HS_DIRS)) \
169         $(addsuffix /*.o,$(HS_DIRS)) \
170         $(PYTHON_BOOTSTRAP) \
171         epydoc.conf \
172         $(REPLACE_VARS_SED) \
173         $(SHELL_ENV_INIT) \
174         daemons/daemon-util \
175         daemons/ganeti-cleaner \
176         $(mandocrst) \
177         doc/manpages-enabled.rst \
178         $(BUILT_EXAMPLES) \
179         doc/examples/bash_completion \
180         doc/examples/bash_completion-debug \
181         lib/_generated_rpc.py \
182         $(man_MANS) \
183         $(manhtml) \
184         tools/kvm-ifup \
185         tools/vcluster-setup \
186         stamp-directories \
187         stamp-srclinks \
188         $(nodist_pkgpython_PYTHON) \
189         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
190         $(HS_BUILT_TEST_HELPERS) \
191         src/ganeti-confd \
192         .hpc/*.mix src/*.tix test/hs/*.tix \
193         doc/hs-lint.html
194
195 GENERATED_FILES = \
196         $(built_base_sources) \
197         $(BUILT_PYTHON_SOURCES) \
198         $(PYTHON_BOOTSTRAP)
199
200 HS_GENERATED_FILES =
201 if WANT_HTOOLS
202 HS_GENERATED_FILES += $(HS_PROGS)
203 if ENABLE_CONFD
204 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
205 endif
206 endif
207
208 built_base_sources = \
209         stamp-directories \
210         stamp-srclinks
211
212 built_python_base_sources = \
213         lib/_autoconf.py \
214         lib/_vcsversion.py
215
216 BUILT_PYTHON_SOURCES = \
217         $(built_python_base_sources) \
218         lib/_generated_rpc.py
219
220 # Generating the RPC wrappers depends on many things, so make sure
221 # it's built at the end of the built sources
222 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
223
224 # these are all built from the underlying %.in sources
225 BUILT_EXAMPLES = \
226         doc/examples/ganeti-kvm-poweroff.initd \
227         doc/examples/ganeti.cron \
228         doc/examples/ganeti.initd \
229         doc/examples/ganeti-master-role.ocf \
230         doc/examples/ganeti-node-role.ocf \
231         doc/examples/gnt-config-backup \
232         doc/examples/hooks/ipsec
233
234 nodist_pkgpython_PYTHON = \
235         $(BUILT_PYTHON_SOURCES)
236
237 noinst_PYTHON = \
238         lib/build/__init__.py \
239         lib/build/shell_example_lexer.py \
240         lib/build/sphinx_ext.py
241
242 pkgpython_PYTHON = \
243         lib/__init__.py \
244         lib/asyncnotifier.py \
245         lib/backend.py \
246         lib/bdev.py \
247         lib/bootstrap.py \
248         lib/cli.py \
249         lib/cmdlib.py \
250         lib/compat.py \
251         lib/config.py \
252         lib/constants.py \
253         lib/daemon.py \
254         lib/errors.py \
255         lib/ht.py \
256         lib/jqueue.py \
257         lib/jstore.py \
258         lib/locking.py \
259         lib/luxi.py \
260         lib/mcpu.py \
261         lib/netutils.py \
262         lib/objects.py \
263         lib/objectutils.py \
264         lib/opcodes.py \
265         lib/ovf.py \
266         lib/pathutils.py \
267         lib/qlang.py \
268         lib/query.py \
269         lib/rpc.py \
270         lib/rpc_defs.py \
271         lib/runtime.py \
272         lib/serializer.py \
273         lib/ssconf.py \
274         lib/ssh.py \
275         lib/storage.py \
276         lib/uidpool.py \
277         lib/vcluster.py \
278         lib/network.py \
279         lib/workerpool.py
280
281 client_PYTHON = \
282         lib/client/__init__.py \
283         lib/client/gnt_backup.py \
284         lib/client/gnt_cluster.py \
285         lib/client/gnt_debug.py \
286         lib/client/gnt_group.py \
287         lib/client/gnt_instance.py \
288         lib/client/gnt_job.py \
289         lib/client/gnt_node.py \
290         lib/client/gnt_network.py \
291         lib/client/gnt_os.py \
292         lib/client/gnt_storage.py
293
294 hypervisor_PYTHON = \
295         lib/hypervisor/__init__.py \
296         lib/hypervisor/hv_base.py \
297         lib/hypervisor/hv_chroot.py \
298         lib/hypervisor/hv_fake.py \
299         lib/hypervisor/hv_kvm.py \
300         lib/hypervisor/hv_lxc.py \
301         lib/hypervisor/hv_xen.py
302
303 rapi_PYTHON = \
304         lib/rapi/__init__.py \
305         lib/rapi/baserlib.py \
306         lib/rapi/client.py \
307         lib/rapi/client_utils.py \
308         lib/rapi/connector.py \
309         lib/rapi/rlib2.py \
310         lib/rapi/testutils.py
311
312 http_PYTHON = \
313         lib/http/__init__.py \
314         lib/http/auth.py \
315         lib/http/client.py \
316         lib/http/server.py
317
318 confd_PYTHON = \
319         lib/confd/__init__.py \
320         lib/confd/client.py
321
322 masterd_PYTHON = \
323         lib/masterd/__init__.py \
324         lib/masterd/iallocator.py \
325         lib/masterd/instance.py
326
327 impexpd_PYTHON = \
328         lib/impexpd/__init__.py
329
330 watcher_PYTHON = \
331         lib/watcher/__init__.py \
332         lib/watcher/nodemaint.py \
333         lib/watcher/state.py
334
335 server_PYTHON = \
336         lib/server/__init__.py \
337         lib/server/masterd.py \
338         lib/server/noded.py \
339         lib/server/rapi.py
340
341 pytools_PYTHON = \
342         lib/tools/__init__.py \
343         lib/tools/burnin.py \
344         lib/tools/ensure_dirs.py \
345         lib/tools/node_cleanup.py \
346         lib/tools/node_daemon_setup.py \
347         lib/tools/prepare_node_join.py
348
349 utils_PYTHON = \
350         lib/utils/__init__.py \
351         lib/utils/algo.py \
352         lib/utils/filelock.py \
353         lib/utils/hash.py \
354         lib/utils/io.py \
355         lib/utils/log.py \
356         lib/utils/lvm.py \
357         lib/utils/mlock.py \
358         lib/utils/nodesetup.py \
359         lib/utils/process.py \
360         lib/utils/retry.py \
361         lib/utils/text.py \
362         lib/utils/wrapper.py \
363         lib/utils/x509.py
364
365 docinput = \
366         doc/conf.py \
367         doc/css/style.css \
368         doc/admin.rst \
369         doc/cluster-merge.rst \
370         doc/design-2.0.rst \
371         doc/design-2.1.rst \
372         doc/design-2.2.rst \
373         doc/design-2.3.rst \
374         doc/design-2.4.rst \
375         doc/design-2.5.rst \
376         doc/design-2.6.rst \
377         doc/design-2.7.rst \
378         doc/design-autorepair.rst \
379         doc/design-bulk-create.rst \
380         doc/design-chained-jobs.rst \
381         doc/design-cpu-pinning.rst \
382         doc/design-draft.rst \
383         doc/design-htools-2.3.rst \
384         doc/design-http-server.rst \
385         doc/design-impexp2.rst \
386         doc/design-lu-generated-jobs.rst \
387         doc/design-linuxha.rst \
388         doc/design-multi-reloc.rst \
389         doc/design-network.rst \
390         doc/design-node-add.rst \
391         doc/design-oob.rst \
392         doc/design-ovf-support.rst \
393         doc/design-opportunistic-locking.rst \
394         doc/design-partitioned.rst \
395         doc/design-query-splitting.rst \
396         doc/design-query2.rst \
397         doc/design-remote-commands.rst \
398         doc/design-resource-model.rst \
399         doc/design-shared-storage.rst \
400         doc/design-monitoring-agent.rst \
401         doc/design-virtual-clusters.rst \
402         doc/design-x509-ca.rst \
403         doc/devnotes.rst \
404         doc/glossary.rst \
405         doc/hooks.rst \
406         doc/iallocator.rst \
407         doc/index.rst \
408         doc/install-quick.rst \
409         doc/install.rst \
410         doc/locking.rst \
411         doc/manpages-disabled.rst \
412         doc/move-instance.rst \
413         doc/news.rst \
414         doc/ovfconverter.rst \
415         doc/rapi.rst \
416         doc/security.rst \
417         doc/upgrade.rst \
418         doc/virtual-cluster.rst \
419         doc/walkthrough.rst
420
421 # Generates file names such as "doc/man-gnt-instance.rst"
422 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
423
424 # Haskell programs to be installed in $PREFIX/bin
425 HS_BIN_PROGS=src/htools
426
427 # Haskell programs to be installed in the MYEXECLIB dir
428 HS_MYEXECLIB_PROGS=src/mon-collector
429
430 # Haskell programs to compiled but not installed automatically
431 # Usually they have their own specific installation rules
432 HS_COMPILE_PROGS= \
433         src/hconfd \
434         src/rpc-test
435
436 # All Haskell non-test programs to be compiled but not automatically installed
437 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
438
439 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
440 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
441
442 HS_ALL_PROGS = \
443         $(HS_PROGS) \
444         test/hs/hpc-htools \
445         test/hs/hpc-mon-collector \
446         test/hs/htest \
447         $(HS_COMPILE_PROGS)
448
449 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
450 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
451
452 HFLAGS = \
453         -O -Wall -Werror -isrc \
454         -fwarn-monomorphism-restriction \
455         -fwarn-tabs \
456         $(GHC_BYVERSION_FLAGS)
457
458 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
459 HEXTRA =
460 # internal extra flags (used for test/hs/htest mainly)
461 HEXTRA_INT =
462 # exclude options for coverage reports
463 HPCEXCL = --exclude Main \
464         --exclude Ganeti.Constants \
465         --exclude Ganeti.HTools.QC \
466         --exclude Ganeti.THH \
467         --exclude Ganeti.Version \
468         --exclude Test.Ganeti.Attoparsec \
469         --exclude Test.Ganeti.TestCommon \
470         --exclude Test.Ganeti.TestHTools \
471         --exclude Test.Ganeti.TestHelper \
472         --exclude Test.Ganeti.TestImports \
473         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
474
475 HS_LIB_SRCS = \
476         src/Ganeti/Block/Drbd/Types.hs \
477         src/Ganeti/Block/Drbd/Parser.hs \
478         src/Ganeti/BasicTypes.hs \
479         src/Ganeti/Common.hs \
480         src/Ganeti/Compat.hs \
481         src/Ganeti/Confd/Client.hs \
482         src/Ganeti/Confd/Server.hs \
483         src/Ganeti/Confd/Types.hs \
484         src/Ganeti/Confd/Utils.hs \
485         src/Ganeti/Config.hs \
486         src/Ganeti/Daemon.hs \
487         src/Ganeti/DataCollectors/CLI.hs \
488         src/Ganeti/DataCollectors/Drbd.hs \
489         src/Ganeti/DataCollectors/Program.hs \
490         src/Ganeti/Errors.hs \
491         src/Ganeti/HTools/Backend/IAlloc.hs \
492         src/Ganeti/HTools/Backend/Luxi.hs \
493         src/Ganeti/HTools/Backend/Rapi.hs \
494         src/Ganeti/HTools/Backend/Simu.hs \
495         src/Ganeti/HTools/Backend/Text.hs \
496         src/Ganeti/HTools/CLI.hs \
497         src/Ganeti/HTools/Cluster.hs \
498         src/Ganeti/HTools/Container.hs \
499         src/Ganeti/HTools/ExtLoader.hs \
500         src/Ganeti/HTools/Graph.hs \
501         src/Ganeti/HTools/Group.hs \
502         src/Ganeti/HTools/Instance.hs \
503         src/Ganeti/HTools/Loader.hs \
504         src/Ganeti/HTools/Node.hs \
505         src/Ganeti/HTools/PeerMap.hs \
506         src/Ganeti/HTools/Program/Hail.hs \
507         src/Ganeti/HTools/Program/Hbal.hs \
508         src/Ganeti/HTools/Program/Hcheck.hs \
509         src/Ganeti/HTools/Program/Hinfo.hs \
510         src/Ganeti/HTools/Program/Hscan.hs \
511         src/Ganeti/HTools/Program/Hspace.hs \
512         src/Ganeti/HTools/Program/Hroller.hs \
513         src/Ganeti/HTools/Program/Main.hs \
514         src/Ganeti/HTools/Types.hs \
515         src/Ganeti/Hash.hs \
516         src/Ganeti/JQueue.hs \
517         src/Ganeti/JSON.hs \
518         src/Ganeti/Jobs.hs \
519         src/Ganeti/Logging.hs \
520         src/Ganeti/Luxi.hs \
521         src/Ganeti/Network.hs \
522         src/Ganeti/Objects.hs \
523         src/Ganeti/OpCodes.hs \
524         src/Ganeti/OpParams.hs \
525         src/Ganeti/Path.hs \
526         src/Ganeti/Query/Common.hs \
527         src/Ganeti/Query/Filter.hs \
528         src/Ganeti/Query/Group.hs \
529         src/Ganeti/Query/Job.hs \
530         src/Ganeti/Query/Language.hs \
531         src/Ganeti/Query/Node.hs \
532         src/Ganeti/Query/Query.hs \
533         src/Ganeti/Query/Server.hs \
534         src/Ganeti/Query/Types.hs \
535         src/Ganeti/Rpc.hs \
536         src/Ganeti/Runtime.hs \
537         src/Ganeti/Ssconf.hs \
538         src/Ganeti/THH.hs \
539         src/Ganeti/Types.hs \
540         src/Ganeti/Utils.hs
541
542 HS_TEST_SRCS = \
543         test/hs/Test/Ganeti/Attoparsec.hs \
544         test/hs/Test/Ganeti/BasicTypes.hs \
545         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
546         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
547         test/hs/Test/Ganeti/Common.hs \
548         test/hs/Test/Ganeti/Confd/Types.hs \
549         test/hs/Test/Ganeti/Confd/Utils.hs \
550         test/hs/Test/Ganeti/Daemon.hs \
551         test/hs/Test/Ganeti/Errors.hs \
552         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
553         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
554         test/hs/Test/Ganeti/HTools/CLI.hs \
555         test/hs/Test/Ganeti/HTools/Cluster.hs \
556         test/hs/Test/Ganeti/HTools/Container.hs \
557         test/hs/Test/Ganeti/HTools/Graph.hs \
558         test/hs/Test/Ganeti/HTools/Instance.hs \
559         test/hs/Test/Ganeti/HTools/Loader.hs \
560         test/hs/Test/Ganeti/HTools/Node.hs \
561         test/hs/Test/Ganeti/HTools/PeerMap.hs \
562         test/hs/Test/Ganeti/HTools/Types.hs \
563         test/hs/Test/Ganeti/JSON.hs \
564         test/hs/Test/Ganeti/Jobs.hs \
565         test/hs/Test/Ganeti/JQueue.hs \
566         test/hs/Test/Ganeti/Luxi.hs \
567         test/hs/Test/Ganeti/Network.hs \
568         test/hs/Test/Ganeti/Objects.hs \
569         test/hs/Test/Ganeti/OpCodes.hs \
570         test/hs/Test/Ganeti/Query/Filter.hs \
571         test/hs/Test/Ganeti/Query/Language.hs \
572         test/hs/Test/Ganeti/Query/Query.hs \
573         test/hs/Test/Ganeti/Rpc.hs \
574         test/hs/Test/Ganeti/Ssconf.hs \
575         test/hs/Test/Ganeti/THH.hs \
576         test/hs/Test/Ganeti/TestCommon.hs \
577         test/hs/Test/Ganeti/TestHTools.hs \
578         test/hs/Test/Ganeti/TestHelper.hs \
579         test/hs/Test/Ganeti/Types.hs \
580         test/hs/Test/Ganeti/Utils.hs
581
582 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
583
584 HS_BUILT_SRCS = \
585         test/hs/Test/Ganeti/TestImports.hs \
586         src/Ganeti/Constants.hs \
587         src/Ganeti/Version.hs
588 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
589
590 $(RUN_IN_TEMPDIR): | stamp-directories
591
592 doc/html/index.html: ENABLE_MANPAGES =
593 doc/man-html/index.html: ENABLE_MANPAGES = 1
594 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
595
596 # Note: we use here an order-only prerequisite, as the contents of
597 # _autoconf.py are not actually influencing the html build output: it
598 # has to exist in order for the sphinx module to be loaded
599 # successfully, but we certainly don't want the docs to be rebuilt if
600 # it changes
601 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
602         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
603         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
604         doc/css/style.css \
605         | $(BUILT_PYTHON_SOURCES)
606         @test -n "$(SPHINX)" || \
607             { echo 'sphinx-build' not found during configure; exit 1; }
608 if !MANPAGES_IN_DOC
609         if test -n '$(ENABLE_MANPAGES)'; then \
610           echo 'Man pages in documentation were disabled at configure time' >&2; \
611           exit 1; \
612         fi
613 endif
614         dir=$(dir $@) && \
615         @mkdir_p@ $$dir && \
616         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) \
617         $(RUN_IN_TEMPDIR) bash autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
618             -d . \
619             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
620             -D release="$(PACKAGE_VERSION)" \
621             -D graphviz_dot="$(DOT)" \
622             -D enable_manpages="$(ENABLE_MANPAGES)" \
623             doc $(CURDIR)/$$dir && \
624         rm -f $$dir/.buildinfo $$dir/objects.inv
625         touch $@
626
627 doc/html: doc/html/index.html
628
629 doc/man-html: doc/man-html/index.html
630
631 doc/install-quick.rst: INSTALL
632 doc/news.rst: NEWS
633 doc/upgrade.rst: UPGRADE
634
635 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
636         set -e; \
637         { echo '.. This file is automatically updated at build time from $<.'; \
638           echo '.. Do not edit.'; \
639           echo; \
640           cat $<; \
641         } > $@
642
643 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
644         { echo '.. This file is automatically generated, do not edit!'; \
645           echo ''; \
646           echo 'Man pages'; \
647           echo '========='; \
648           echo; \
649           echo '.. toctree::'; \
650           echo '   :maxdepth: 1'; \
651           echo; \
652           for i in $(notdir $(mandocrst)); do \
653             echo "   $$i"; \
654           done | LC_ALL=C sort; \
655         } > $@
656
657 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
658 if MANPAGES_IN_DOC
659         { echo '.. This file is automatically updated at build time from $<.'; \
660           echo '.. Do not edit.'; \
661           echo; \
662           echo "$*"; \
663           echo '=========================================='; \
664           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
665         } > $@
666 else
667         echo 'Man pages in documentation were disabled at configure time' >&2; \
668         exit 1;
669 endif
670
671 # Things to build but not to install (add it to EXTRA_DIST if it should be
672 # distributed)
673 noinst_DATA = \
674         doc/html \
675         $(BUILT_EXAMPLES) \
676         doc/examples/bash_completion \
677         doc/examples/bash_completion-debug \
678         $(manhtml)
679
680 if MANPAGES_IN_DOC
681 noinst_DATA += doc/man-html
682 endif
683
684 gnt_scripts = \
685         scripts/gnt-backup \
686         scripts/gnt-cluster \
687         scripts/gnt-debug \
688         scripts/gnt-group \
689         scripts/gnt-instance \
690         scripts/gnt-job \
691         scripts/gnt-network \
692         scripts/gnt-node \
693         scripts/gnt-os \
694         scripts/gnt-storage
695
696 PYTHON_BOOTSTRAP_SBIN = \
697         daemons/ganeti-masterd \
698         daemons/ganeti-noded \
699         daemons/ganeti-rapi \
700         daemons/ganeti-watcher \
701         $(gnt_scripts)
702
703 PYTHON_BOOTSTRAP = \
704         $(PYTHON_BOOTSTRAP_SBIN) \
705         tools/burnin \
706         tools/ensure-dirs \
707         tools/node-cleanup \
708         tools/node-daemon-setup \
709         tools/prepare-node-join
710
711 qa_scripts = \
712         qa/__init__.py \
713         qa/ganeti-qa.py \
714         qa/qa_cluster.py \
715         qa/qa_config.py \
716         qa/qa_daemon.py \
717         qa/qa_env.py \
718         qa/qa_error.py \
719         qa/qa_group.py \
720         qa/qa_instance.py \
721         qa/qa_job.py \
722         qa/qa_node.py \
723         qa/qa_os.py \
724         qa/qa_rapi.py \
725         qa/qa_tags.py \
726         qa/qa_utils.py
727
728 bin_SCRIPTS =
729 if WANT_HTOOLS
730 bin_SCRIPTS += $(HS_BIN_PROGS)
731 install-exec-hook:
732         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
733 # FIXME: this is a hardcoded logic, instead of auto-resolving
734         $(LN_S) -f ../../../bin/htools \
735           $(DESTDIR)$(iallocatorsdir)/hail
736         for role in $(HS_BIN_ROLES); do \
737           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
738         done
739 endif
740
741 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
742         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
743           echo "Error: cannot run unittests without the development" \
744                " libraries (see devnotes.rst)" 1>&2; \
745           exit 1; \
746         fi
747         @rm -f $(notdir $@).tix
748         $(GHC) --make \
749           $(HFLAGS) \
750           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
751           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
752           $(HEXTRA) $(HEXTRA_INT) $@
753         @touch "$@"
754
755 # for the test/hs/htest binary, we need to enable profiling/coverage
756 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
757
758 # we compile the hpc-htools binary with the program coverage
759 test/hs/hpc-htools: HEXTRA_INT=-fhpc
760
761 # we compile the hpc-mon-collector binary with the program coverage
762 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
763
764 # test dependency
765 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
766
767 # rules for building profiling-enabled versions of the haskell
768 # programs: hs-prof does the full two-step build, whereas
769 # hs-prof-quick does only the final rebuild (hs-prof must have been
770 # run before)
771 .PHONY: hs-prof hs-prof-quick
772 hs-prof:
773         @if [ -z "$(TARGET)" ]; then \
774           echo "You need to define TARGET when running this rule" 1>&2; \
775           exit 1; \
776         fi
777         $(MAKE) $(AM_MAKEFLAGS) clean
778         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
779         rm -f $(HS_ALL_PROGS)
780         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
781
782 hs-prof-quick:
783         @if [ -z "$(TARGET)" ]; then \
784           echo "You need to define TARGET when running this rule" 1>&2; \
785           exit 1; \
786         fi
787         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
788
789 dist_sbin_SCRIPTS = \
790         tools/ganeti-listrunner
791
792 nodist_sbin_SCRIPTS = \
793         $(PYTHON_BOOTSTRAP_SBIN) \
794         daemons/ganeti-cleaner
795
796 if ENABLE_CONFD
797 src/ganeti-confd: src/hconfd
798         cp -f $< $@
799
800 nodist_sbin_SCRIPTS += src/ganeti-confd
801 endif
802
803 python_scripts = \
804         tools/cfgshell \
805         tools/cfgupgrade \
806         tools/cfgupgrade12 \
807         tools/cluster-merge \
808         tools/confd-client \
809         tools/fmtjson \
810         tools/lvmstrap \
811         tools/move-instance \
812         tools/ovfconverter \
813         tools/sanitize-config
814
815 dist_tools_SCRIPTS = \
816         $(python_scripts) \
817         tools/kvm-console-wrapper \
818         tools/master-ip-setup \
819         tools/xen-console-wrapper
820
821 nodist_tools_python_scripts = \
822         tools/node-cleanup
823
824 nodist_tools_SCRIPTS = \
825         $(nodist_tools_python_scripts) \
826         tools/vcluster-setup
827
828 pkglib_python_scripts = \
829         daemons/import-export \
830         tools/check-cert-expired
831
832 nodist_pkglib_python_scripts = \
833         tools/burnin \
834         tools/ensure-dirs \
835         tools/node-daemon-setup \
836         tools/prepare-node-join
837
838 myexeclib_SCRIPTS = \
839         daemons/daemon-util \
840         tools/kvm-ifup \
841         $(pkglib_python_scripts) \
842         $(HS_MYEXECLIB_PROGS)
843
844 nodist_myexeclib_SCRIPTS = \
845         $(nodist_pkglib_python_scripts)
846
847 EXTRA_DIST = \
848         NEWS \
849         UPGRADE \
850         epydoc.conf.in \
851         pylintrc \
852         autotools/build-bash-completion \
853         autotools/build-rpc \
854         autotools/check-header \
855         autotools/check-imports \
856         autotools/check-man-dashes \
857         autotools/check-man-references \
858         autotools/check-man-warnings \
859         autotools/check-news \
860         autotools/check-python-code \
861         autotools/check-tar \
862         autotools/check-version \
863         autotools/convert-constants \
864         autotools/docpp \
865         autotools/gen-py-coverage \
866         autotools/sphinx-wrapper \
867         autotools/testrunner \
868         autotools/wrong-hardcoded-paths \
869         $(RUN_IN_TEMPDIR) \
870         daemons/daemon-util.in \
871         daemons/ganeti-cleaner.in \
872         $(pkglib_python_scripts) \
873         devel/upload \
874         devel/webserver \
875         tools/kvm-ifup.in \
876         tools/vcluster-setup.in \
877         $(docinput) \
878         doc/html \
879         $(BUILT_EXAMPLES:%=%.in) \
880         doc/examples/ganeti.default \
881         doc/examples/ganeti.default-debug \
882         doc/examples/hooks/ethers \
883         doc/examples/gnt-debug/README \
884         doc/examples/gnt-debug/delay0.json \
885         doc/examples/gnt-debug/delay50.json \
886         test/py/lockperf.py \
887         test/py/testutils.py \
888         test/py/mocks.py \
889         $(dist_TESTS) \
890         $(TEST_FILES) \
891         man/footer.rst \
892         $(manrst) \
893         $(maninput) \
894         qa/qa-sample.json \
895         $(qa_scripts) \
896         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
897         $(HS_PROG_SRCS) \
898         src/lint-hints.hs \
899         test/hs/cli-tests-defs.sh \
900         test/hs/offline-test.sh \
901         .ghci
902
903 man_MANS = \
904         man/ganeti-cleaner.8 \
905         man/ganeti-confd.8 \
906         man/ganeti-listrunner.8 \
907         man/ganeti-masterd.8 \
908         man/ganeti-noded.8 \
909         man/ganeti-os-interface.7 \
910         man/ganeti-extstorage-interface.7 \
911         man/ganeti-rapi.8 \
912         man/ganeti-watcher.8 \
913         man/ganeti.7 \
914         man/gnt-backup.8 \
915         man/gnt-cluster.8 \
916         man/gnt-debug.8 \
917         man/gnt-group.8 \
918         man/gnt-network.8 \
919         man/gnt-instance.8 \
920         man/gnt-job.8 \
921         man/gnt-node.8 \
922         man/gnt-os.8 \
923         man/gnt-storage.8 \
924         man/hail.1 \
925         man/hbal.1 \
926         man/hcheck.1 \
927         man/hinfo.1 \
928         man/hscan.1 \
929         man/hspace.1 \
930         man/hroller.1 \
931         man/htools.1 \
932         man/mon-collector.7
933
934 # Remove extensions from all filenames in man_MANS
935 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
936
937 manrst = $(patsubst %,%.rst,$(mannoext))
938 manhtml = $(patsubst %.rst,%.html,$(manrst))
939 mangen = $(patsubst %.rst,%.gen,$(manrst))
940 maninput = \
941         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
942         $(patsubst %.html,%.html.in,$(manhtml)) \
943         $(mangen)
944
945 TEST_FILES = \
946         test/data/htools/clean-nonzero-score.data \
947         test/data/htools/common-suffix.data \
948         test/data/htools/empty-cluster.data \
949         test/data/htools/hail-alloc-drbd.json \
950         test/data/htools/hail-change-group.json \
951         test/data/htools/hail-invalid-reloc.json \
952         test/data/htools/hail-node-evac.json \
953         test/data/htools/hail-reloc-drbd.json \
954         test/data/htools/hbal-excl-tags.data \
955         test/data/htools/hbal-split-insts.data \
956         test/data/htools/invalid-node.data \
957         test/data/htools/missing-resources.data \
958         test/data/htools/n1-failure.data \
959         test/data/htools/rapi/groups.json \
960         test/data/htools/rapi/info.json \
961         test/data/htools/rapi/instances.json \
962         test/data/htools/rapi/nodes.json \
963         test/hs/shelltests/htools-balancing.test \
964         test/hs/shelltests/htools-basic.test \
965         test/hs/shelltests/htools-dynutil.test \
966         test/hs/shelltests/htools-excl.test \
967         test/hs/shelltests/htools-hail.test \
968         test/hs/shelltests/htools-hspace.test \
969         test/hs/shelltests/htools-invalid.test \
970         test/hs/shelltests/htools-multi-group.test \
971         test/hs/shelltests/htools-no-backend.test \
972         test/hs/shelltests/htools-rapi.test \
973         test/hs/shelltests/htools-single-group.test \
974         test/hs/shelltests/htools-text-backend.test \
975         test/hs/shelltests/htools-mon-collector.test \
976         test/data/bdev-drbd-8.0.txt \
977         test/data/bdev-drbd-8.3.txt \
978         test/data/bdev-drbd-disk.txt \
979         test/data/bdev-drbd-net-ip4.txt \
980         test/data/bdev-drbd-net-ip6.txt \
981         test/data/cert1.pem \
982         test/data/cert2.pem \
983         test/data/instance-minor-pairing.txt \
984         test/data/ip-addr-show-dummy0.txt \
985         test/data/ip-addr-show-lo-ipv4.txt \
986         test/data/ip-addr-show-lo-ipv6.txt \
987         test/data/ip-addr-show-lo-oneline-ipv4.txt \
988         test/data/ip-addr-show-lo-oneline-ipv6.txt \
989         test/data/ip-addr-show-lo-oneline.txt \
990         test/data/ip-addr-show-lo.txt \
991         test/data/kvm_0.12.5_help.txt \
992         test/data/kvm_0.15.90_help.txt \
993         test/data/kvm_0.9.1_help.txt \
994         test/data/kvm_0.9.1_help_boot_test.txt \
995         test/data/kvm_1.0_help.txt \
996         test/data/kvm_1.1.2_help.txt \
997         test/data/ovfdata/compr_disk.vmdk.gz \
998         test/data/ovfdata/config.ini \
999         test/data/ovfdata/corrupted_resources.ovf \
1000         test/data/ovfdata/empty.ini \
1001         test/data/ovfdata/empty.ovf \
1002         test/data/ovfdata/ganeti.mf \
1003         test/data/ovfdata/ganeti.ovf \
1004         test/data/ovfdata/gzip_disk.ovf \
1005         test/data/ovfdata/new_disk.vmdk \
1006         test/data/ovfdata/no_disk.ini \
1007         test/data/ovfdata/no_disk_in_ref.ovf \
1008         test/data/ovfdata/no_os.ini \
1009         test/data/ovfdata/no_ovf.ova \
1010         test/data/ovfdata/other/rawdisk.raw \
1011         test/data/ovfdata/ova.ova \
1012         test/data/ovfdata/rawdisk.raw \
1013         test/data/ovfdata/second_disk.vmdk \
1014         test/data/ovfdata/unsafe_path.ini \
1015         test/data/ovfdata/virtualbox.ovf \
1016         test/data/ovfdata/wrong_config.ini \
1017         test/data/ovfdata/wrong_extension.ovd \
1018         test/data/ovfdata/wrong_manifest.mf \
1019         test/data/ovfdata/wrong_manifest.ovf \
1020         test/data/ovfdata/wrong_ova.ova \
1021         test/data/ovfdata/wrong_xml.ovf \
1022         test/data/proc_drbd8.txt \
1023         test/data/proc_drbd80-emptyline.txt \
1024         test/data/proc_drbd83.txt \
1025         test/data/proc_drbd83_sync.txt \
1026         test/data/proc_drbd83_sync_want.txt \
1027         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1028         test/data/sys_drbd_usermode_helper.txt \
1029         test/data/vgreduce-removemissing-2.02.02.txt \
1030         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1031         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1032         test/data/vgs-missing-pvs-2.02.02.txt \
1033         test/data/vgs-missing-pvs-2.02.66.txt \
1034         test/py/ganeti-cli.test \
1035         test/py/gnt-cli.test \
1036         test/py/import-export_unittest-helper
1037
1038 python_tests = \
1039         doc/examples/rapi_testutils.py \
1040         test/py/cfgupgrade_unittest.py \
1041         test/py/docs_unittest.py \
1042         test/py/ganeti.asyncnotifier_unittest.py \
1043         test/py/ganeti.backend_unittest-runasroot.py \
1044         test/py/ganeti.backend_unittest.py \
1045         test/py/ganeti.bdev_unittest.py \
1046         test/py/ganeti.cli_unittest.py \
1047         test/py/ganeti.client.gnt_cluster_unittest.py \
1048         test/py/ganeti.client.gnt_instance_unittest.py \
1049         test/py/ganeti.client.gnt_job_unittest.py \
1050         test/py/ganeti.cmdlib_unittest.py \
1051         test/py/ganeti.compat_unittest.py \
1052         test/py/ganeti.confd.client_unittest.py \
1053         test/py/ganeti.config_unittest.py \
1054         test/py/ganeti.constants_unittest.py \
1055         test/py/ganeti.daemon_unittest.py \
1056         test/py/ganeti.errors_unittest.py \
1057         test/py/ganeti.hooks_unittest.py \
1058         test/py/ganeti.ht_unittest.py \
1059         test/py/ganeti.http_unittest.py \
1060         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1061         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1062         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1063         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1064         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1065         test/py/ganeti.hypervisor_unittest.py \
1066         test/py/ganeti.impexpd_unittest.py \
1067         test/py/ganeti.jqueue_unittest.py \
1068         test/py/ganeti.jstore_unittest.py \
1069         test/py/ganeti.locking_unittest.py \
1070         test/py/ganeti.luxi_unittest.py \
1071         test/py/ganeti.masterd.iallocator_unittest.py \
1072         test/py/ganeti.masterd.instance_unittest.py \
1073         test/py/ganeti.mcpu_unittest.py \
1074         test/py/ganeti.netutils_unittest.py \
1075         test/py/ganeti.objects_unittest.py \
1076         test/py/ganeti.objectutils_unittest.py \
1077         test/py/ganeti.opcodes_unittest.py \
1078         test/py/ganeti.ovf_unittest.py \
1079         test/py/ganeti.qlang_unittest.py \
1080         test/py/ganeti.query_unittest.py \
1081         test/py/ganeti.rapi.baserlib_unittest.py \
1082         test/py/ganeti.rapi.client_unittest.py \
1083         test/py/ganeti.rapi.resources_unittest.py \
1084         test/py/ganeti.rapi.rlib2_unittest.py \
1085         test/py/ganeti.rapi.testutils_unittest.py \
1086         test/py/ganeti.rpc_unittest.py \
1087         test/py/ganeti.runtime_unittest.py \
1088         test/py/ganeti.serializer_unittest.py \
1089         test/py/ganeti.server.rapi_unittest.py \
1090         test/py/ganeti.ssconf_unittest.py \
1091         test/py/ganeti.ssh_unittest.py \
1092         test/py/ganeti.storage_unittest.py \
1093         test/py/ganeti.tools.burnin_unittest.py \
1094         test/py/ganeti.tools.ensure_dirs_unittest.py \
1095         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1096         test/py/ganeti.tools.prepare_node_join_unittest.py \
1097         test/py/ganeti.uidpool_unittest.py \
1098         test/py/ganeti.utils.algo_unittest.py \
1099         test/py/ganeti.utils.filelock_unittest.py \
1100         test/py/ganeti.utils.hash_unittest.py \
1101         test/py/ganeti.utils.io_unittest-runasroot.py \
1102         test/py/ganeti.utils.io_unittest.py \
1103         test/py/ganeti.utils.log_unittest.py \
1104         test/py/ganeti.utils.lvm_unittest.py \
1105         test/py/ganeti.utils.mlock_unittest.py \
1106         test/py/ganeti.utils.nodesetup_unittest.py \
1107         test/py/ganeti.utils.process_unittest.py \
1108         test/py/ganeti.utils.retry_unittest.py \
1109         test/py/ganeti.utils.text_unittest.py \
1110         test/py/ganeti.utils.wrapper_unittest.py \
1111         test/py/ganeti.utils.x509_unittest.py \
1112         test/py/ganeti.utils_unittest.py \
1113         test/py/ganeti.vcluster_unittest.py \
1114         test/py/ganeti.workerpool_unittest.py \
1115         test/py/pycurl_reset_unittest.py \
1116         test/py/qa.qa_config_unittest.py \
1117         test/py/tempfile_fork_unittest.py
1118
1119 haskell_tests = test/hs/htest
1120
1121 dist_TESTS = \
1122         test/py/check-cert-expired_unittest.bash \
1123         test/py/daemon-util_unittest.bash \
1124         test/py/ganeti-cleaner_unittest.bash \
1125         test/py/import-export_unittest.bash \
1126         test/py/cli-test.bash \
1127         test/py/bash_completion.bash \
1128         $(python_tests)
1129
1130 nodist_TESTS =
1131 check_SCRIPTS =
1132
1133 if WANT_HSTESTS
1134 nodist_TESTS += $(haskell_tests)
1135 dist_TESTS += test/hs/offline-test.sh
1136 check_SCRIPTS += \
1137         test/hs/hpc-htools \
1138         test/hs/hpc-mon-collector \
1139         $(HS_BUILT_TEST_HELPERS)
1140 endif
1141
1142 TESTS = $(dist_TESTS) $(nodist_TESTS)
1143
1144 # Environment for all tests
1145 PLAIN_TESTS_ENVIRONMENT = \
1146         PYTHONPATH=. \
1147         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1148         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1149         $(RUN_IN_TEMPDIR)
1150
1151 # Environment for tests run by automake
1152 TESTS_ENVIRONMENT = \
1153         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1154
1155 all_python_code = \
1156         $(dist_sbin_SCRIPTS) \
1157         $(python_scripts) \
1158         $(pkglib_python_scripts) \
1159         $(nodist_pkglib_python_scripts) \
1160         $(nodist_tools_python_scripts) \
1161         $(python_tests) \
1162         $(pkgpython_PYTHON) \
1163         $(client_PYTHON) \
1164         $(hypervisor_PYTHON) \
1165         $(rapi_PYTHON) \
1166         $(server_PYTHON) \
1167         $(pytools_PYTHON) \
1168         $(http_PYTHON) \
1169         $(confd_PYTHON) \
1170         $(masterd_PYTHON) \
1171         $(impexpd_PYTHON) \
1172         $(utils_PYTHON) \
1173         $(watcher_PYTHON) \
1174         $(noinst_PYTHON) \
1175         $(qa_scripts)
1176
1177 srclink_files = \
1178         man/footer.rst \
1179         test/py/check-cert-expired_unittest.bash \
1180         test/py/daemon-util_unittest.bash \
1181         test/py/ganeti-cleaner_unittest.bash \
1182         test/py/import-export_unittest.bash \
1183         test/py/cli-test.bash \
1184         test/py/bash_completion.bash \
1185         test/hs/offline-test.sh \
1186         test/hs/cli-tests-defs.sh \
1187         $(all_python_code) \
1188         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1189         $(docinput)
1190
1191 check_python_code = \
1192         $(BUILD_BASH_COMPLETION) \
1193         $(CHECK_IMPORTS) \
1194         $(CHECK_HEADER) \
1195         $(DOCPP) \
1196         $(all_python_code)
1197
1198 lint_python_code = \
1199         ganeti \
1200         ganeti/http/server.py \
1201         $(dist_sbin_SCRIPTS) \
1202         $(python_scripts) \
1203         $(pkglib_python_scripts) \
1204         $(BUILD_BASH_COMPLETION) \
1205         $(CHECK_IMPORTS) \
1206         $(CHECK_HEADER) \
1207         $(DOCPP) \
1208         $(PYTHON_BOOTSTRAP)
1209
1210 standalone_python_modules = \
1211         lib/rapi/client.py \
1212         tools/ganeti-listrunner
1213
1214 pep8_python_code = \
1215         ganeti \
1216         ganeti/http/server.py \
1217         $(dist_sbin_SCRIPTS) \
1218         $(python_scripts) \
1219         $(pkglib_python_scripts) \
1220         $(BUILD_BASH_COMPLETION) \
1221         $(CHECK_HEADER) \
1222         $(DOCPP) \
1223         $(PYTHON_BOOTSTRAP) \
1224         qa
1225
1226 test/py/daemon-util_unittest.bash: daemons/daemon-util
1227
1228 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1229
1230 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1231
1232 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1233         sed -f $(REPLACE_VARS_SED) < $< > $@
1234         chmod +x $@
1235
1236 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1237         sed -f $(REPLACE_VARS_SED) < $< > $@
1238         chmod +x $@
1239
1240 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1241         sed -f $(REPLACE_VARS_SED) < $< > $@
1242         chmod +x $@
1243
1244 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1245         sed -f $(REPLACE_VARS_SED) < $< > $@
1246
1247 doc/examples/bash_completion: BC_ARGS = --compact
1248 doc/examples/bash_completion-debug: BC_ARGS =
1249
1250 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1251         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1252         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1253         daemons/ganeti-cleaner \
1254         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1255         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1256           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1257
1258 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1259         lib/build/shell_example_lexer.py \
1260         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1261         @echo "Checking $< for hardcoded paths..."
1262         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1263           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1264           exit 1; \
1265         fi
1266         set -e ; \
1267         trap 'echo auto-removing $@; rm $@' EXIT; \
1268         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1269         $(CHECK_MAN_REFERENCES) $@; \
1270         trap - EXIT
1271
1272 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1273         @test -n "$(PANDOC)" || \
1274           { echo 'pandoc' not found during configure; exit 1; }
1275         set -o pipefail ; \
1276         trap 'echo auto-removing $@; rm $@' EXIT; \
1277         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1278           sed -e 's/\\@/@/g' > $@; \
1279         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1280         $(CHECK_MAN_DASHES) $@; \
1281         trap - EXIT
1282
1283 man/%.html.in: man/%.gen man/footer.rst
1284         @test -n "$(PANDOC)" || \
1285           { echo 'pandoc' not found during configure; exit 1; }
1286         set -o pipefail ; \
1287         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1288           sed -e 's/\\@/@/g' > $@
1289
1290 man/%: man/%.in  $(REPLACE_VARS_SED)
1291         sed -f $(REPLACE_VARS_SED) < $< > $@
1292
1293 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1294         sed -f $(REPLACE_VARS_SED) < $< > $@
1295
1296 vcs-version:
1297         if test -d .git; then \
1298           git describe > $@; \
1299         elif test ! -f $@ ; then \
1300           echo "Cannot auto-generate $@ file"; exit 1; \
1301         fi
1302
1303 .PHONY: clean-vcs-version
1304 clean-vcs-version:
1305         rm -f vcs-version
1306
1307 .PHONY: regen-vcs-version
1308 regen-vcs-version:
1309         @set -e; \
1310         cd $(srcdir); \
1311         if test -d .git; then \
1312           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1313           git describe > $$T; \
1314           if ! cmp --quiet $$T vcs-version; then \
1315             mv $$T vcs-version; \
1316           fi; \
1317         fi
1318
1319 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1320         vcs-version $(built_base_sources)
1321         set -e; \
1322         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1323         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1324
1325 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1326         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1327         lib/jstore.py $(RUN_IN_TEMPDIR) \
1328         $(CONVERT_CONSTANTS) $(built_base_sources) \
1329         | lib/_vcsversion.py
1330         set -e; \
1331         { cat $< ; \
1332           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1333         } > $@
1334
1335 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1336         $(built_base_sources)
1337         set -e; \
1338         { cat $< ; \
1339           echo ; \
1340           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1341             echo "import $$name ()" ; \
1342           done ; \
1343         } > $@
1344
1345 lib/_autoconf.py: Makefile | stamp-directories
1346         set -e; \
1347         { echo '# This file is automatically generated, do not edit!'; \
1348           echo '#'; \
1349           echo ''; \
1350           echo '"""Build-time configuration for Ganeti.'; \
1351           echo '';\
1352           echo 'This file is autogenerated by the build process.'; \
1353           echo 'For any changes you need to re-run ./configure (and'; \
1354           echo 'not edit by hand).'; \
1355           echo ''; \
1356           echo '"""'; \
1357           echo ''; \
1358           echo '# pylint: disable=C0301,C0324'; \
1359           echo '# because this is autogenerated, we do not want'; \
1360           echo '# style warnings' ; \
1361           echo ''; \
1362           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1363           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1364           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1365           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1366           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1367           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1368           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1369           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1370           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1371           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1372           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1373           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1374           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1375           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1376           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1377           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1378           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1379           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1380           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1381           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1382           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1383           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1384           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1385           echo "KVM_PATH = '$(KVM_PATH)'"; \
1386           echo "IP_PATH = '$(IP_PATH)'"; \
1387           echo "SOCAT_PATH = '$(SOCAT)'"; \
1388           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1389           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1390           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1391           echo "TOOLSDIR = '$(toolsdir)'"; \
1392           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1393           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1394           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1395           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1396           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1397           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1398           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1399           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1400           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1401           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1402           echo "RAPI_USER = '$(RAPI_USER)'"; \
1403           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1404           echo "CONFD_USER = '$(CONFD_USER)'"; \
1405           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1406           echo "NODED_USER = '$(NODED_USER)'"; \
1407           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1408           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1409           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1410           echo "HTOOLS = True"; \
1411           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1412           echo "XEN_CMD = '$(XEN_CMD)'"; \
1413           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1414           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1415           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1416 ## Write dictionary with man page name as the key and the section number as the
1417 ## value
1418           echo "MAN_PAGES = {"; \
1419           for i in $(notdir $(man_MANS)); do \
1420             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1421           done; \
1422           echo "}"; \
1423         } > $@
1424
1425 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1426         set -e; \
1427         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1428         { echo '# This file is automatically generated, do not edit!'; \
1429           echo '#'; \
1430           echo ''; \
1431           echo '"""Build-time VCS version number for Ganeti.'; \
1432           echo '';\
1433           echo 'This file is autogenerated by the build process.'; \
1434           echo 'For any changes you need to re-run ./configure (and'; \
1435           echo 'not edit by hand).'; \
1436           echo ''; \
1437           echo '"""'; \
1438           echo ''; \
1439           echo '# pylint: disable=C0301,C0324'; \
1440           echo '# because this is autogenerated, we do not want'; \
1441           echo '# style warnings' ; \
1442           echo ''; \
1443           echo "VCS_VERSION = '$$VCSVER'"; \
1444         } > $@
1445
1446 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1447         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1448
1449 $(SHELL_ENV_INIT): Makefile stamp-directories
1450         set -e; \
1451         { echo '# Allow overriding for tests'; \
1452           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1453           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1454           echo; \
1455           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1456           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1457           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1458           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1459           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1460         } > $@
1461
1462 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1463         set -e; \
1464         { echo 's#@PREFIX@#$(prefix)#g'; \
1465           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1466           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1467           echo 's#@BINDIR@#$(bindir)#g'; \
1468           echo 's#@SBINDIR@#$(sbindir)#g'; \
1469           echo 's#@LIBDIR@#$(libdir)#g'; \
1470           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1471           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1472           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1473           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1474           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1475           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1476           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1477           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1478           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1479           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1480           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1481           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1482           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1483           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1484           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1485           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1486           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1487           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1488           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1489           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1490           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1491           echo; \
1492           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1493           echo '  r $(SHELL_ENV_INIT)'; \
1494           echo '  d'; \
1495           echo '}'; \
1496         } > $@
1497
1498 # Using deferred evaluation
1499 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1500 daemons/ganeti-watcher: MODULE = ganeti.watcher
1501 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1502 tools/burnin: MODULE = ganeti.tools.burnin
1503 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1504 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1505 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1506 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1507 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1508
1509 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1510         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1511         set -e; \
1512         { echo '#!/usr/bin/python'; \
1513           echo '# This file is automatically generated, do not edit!'; \
1514           echo "# Edit $(MODULE) instead."; \
1515           echo; \
1516           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1517           echo; \
1518           echo '# pylint: disable=C0103'; \
1519           echo '# C0103: Invalid name'; \
1520           echo; \
1521           echo 'import sys'; \
1522           echo 'import $(MODULE) as main'; \
1523           echo; \
1524           echo '# Temporarily alias commands until bash completion'; \
1525           echo '# generator is changed'; \
1526           echo 'if hasattr(main, "commands"):'; \
1527           echo '  commands = main.commands # pylint: disable=E1101'; \
1528           echo 'if hasattr(main, "aliases"):'; \
1529           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1530           echo; \
1531           echo 'if __name__ == "__main__":'; \
1532           echo '  sys.exit(main.Main())'; \
1533         } > $@
1534         chmod u+x $@
1535
1536 $(HS_BUILT_TEST_HELPERS): Makefile
1537         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1538         set -e; \
1539         { echo '#!/bin/sh'; \
1540           echo '# This file is automatically generated, do not edit!'; \
1541           echo "# Edit Makefile.am instead."; \
1542           echo; \
1543           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1544         } > $@
1545         chmod u+x $@
1546
1547 stamp-directories: Makefile
1548         $(MAKE) $(AM_MAKEFLAGS) ganeti
1549         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1550         touch $@
1551
1552 # We need to create symlinks because "make distcheck" will not install Python
1553 # files when building.
1554 stamp-srclinks: Makefile | stamp-directories
1555         set -e; \
1556         for i in $(srclink_files); do \
1557           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1558             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1559           fi; \
1560         done
1561         touch $@
1562
1563 .PHONY: ganeti
1564 ganeti:
1565         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1566
1567 .PHONY: check-dirs
1568 check-dirs: $(GENERATED_FILES)
1569         @set -e; \
1570         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1571           error=; \
1572           while read dir; do \
1573             case "$$dir" in \
1574               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1575               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1576             esac; \
1577           done; \
1578           for dir in $(DIRS); do \
1579             if ! test -d "$$dir"; then \
1580               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1581               error=1; \
1582             fi \
1583           done; \
1584           test -z "$$error"; \
1585         }
1586
1587 .PHONY: check-local
1588 check-local: check-dirs $(GENERATED_FILES)
1589         $(CHECK_PYTHON_CODE) $(check_python_code)
1590         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1591         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1592         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1593         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1594         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1595         error= ; \
1596         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1597           echo "Incorrect version in README, expected $$expver" >&2; \
1598           error=1; \
1599         fi; \
1600         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1601             doc/security.rst; do \
1602           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1603             "Documents Ganeti version $$expver"; then \
1604             echo "Incorrect version in $$file, expected $$expver" >&2; \
1605             error=1; \
1606           fi; \
1607         done; \
1608         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1609           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1610           error=1; \
1611         fi; \
1612         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1613           ".. Last updated for Ganeti $$expver"; then \
1614           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1615           error=1; \
1616         fi; \
1617         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1618           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1619             echo "Longest line in $$file is longer than 80 characters" >&2; \
1620             error=1; \
1621           fi; \
1622         done; \
1623         test -z "$$error"
1624
1625 .PHONY: hs-tests
1626 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1627         @rm -f htest.tix
1628         ./test/hs/htest
1629
1630 .PHONY: hs-shell
1631 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1632         @rm -f hpc-htools.tix hpc-mon-collector.tix
1633         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1634
1635 .PHONY: hs-check
1636 hs-check: hs-tests hs-shell
1637
1638 # E111: indentation is not a multiple of four
1639 # E121: continuation line indentation is not a multiple of four
1640 #       (since our indent level is not 4)
1641 # E125: continuation line does not distinguish itself from next logical line
1642 #       (since our indent level is not 4)
1643 # E127: continuation line over-indented for visual indent
1644 #       (since our indent level is not 4)
1645 # note: do NOT add E128 here; it's a valid style error in most cases!
1646 # I've seen real errors, but also some cases were we indent wrongly
1647 # due to line length; try to rework the cases where it is triggered,
1648 # instead of silencing it
1649 # E261: at least two spaces before inline comment
1650 # E501: line too long (80 characters)
1651 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1652
1653 # For excluding pep8 expects filenames only, not whole paths
1654 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1655
1656 LINT_TARGETS = pylint pylint-qa
1657 if HAS_PEP8
1658 LINT_TARGETS += pep8
1659 endif
1660 if HAS_HLINT
1661 LINT_TARGETS += hlint
1662 endif
1663
1664 .PHONY: lint
1665 lint: $(LINT_TARGETS)
1666
1667 .PHONY: pylint
1668 pylint: $(GENERATED_FILES)
1669         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1670         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1671
1672 .PHONY: pylint-qa
1673 pylint-qa: $(GENERATED_FILES)
1674         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1675         cd $(top_srcdir)/qa && \
1676           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1677           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1678
1679 .PHONY: pep8
1680 pep8: $(GENERATED_FILES)
1681         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1682         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1683           --repeat $(pep8_python_code)
1684
1685 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1686 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1687 .PHONY: hlint
1688 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1689         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1690         if tty -s; then C="-c"; else C=""; fi; \
1691         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1692           --ignore "Use first" \
1693           --ignore "Use &&&" \
1694           --ignore "Use void" \
1695           --ignore "Reduce duplication" \
1696           --hint src/lint-hints \
1697           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1698
1699 # a dist hook rule for updating the vcs-version file; this is
1700 # hardcoded due to where it needs to build the file...
1701 dist-hook:
1702         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1703         rm -f $(top_distdir)/vcs-version
1704         cp -p $(srcdir)/vcs-version $(top_distdir)
1705 if MANPAGES_IN_DOC
1706         echo 'Building distribution with man pages included in documentation is' \
1707              'not allowed as they can contain fixed paths' >&2; \
1708         exit 1
1709 endif
1710
1711 # a distcheck hook rule for catching revision control directories
1712 distcheck-hook:
1713         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1714           echo "Found revision control files in final archive." 1>&2; \
1715           exit 1; \
1716         fi
1717         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1718           echo "Found Python byte code in final archive." 1>&2; \
1719           exit 1; \
1720         fi
1721         if find $(top_distdir) -name '*~' | grep .; then \
1722           echo "Found backup files in final archive." 1>&2; \
1723           exit 1; \
1724         fi
1725 # Empty files or directories should not be distributed. They can cause
1726 # unnecessary warnings for packagers. Directories used by automake during
1727 # distcheck must be excluded.
1728         if find $(top_distdir) -empty -and -not \( \
1729             -path $(top_distdir)/_build -or \
1730             -path $(top_distdir)/_inst \) | grep .; then \
1731           echo "Found empty files or directories in final archive." 1>&2; \
1732           exit 1; \
1733         fi
1734         if test -n "$(BUILD_RELEASE)" && \
1735            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1736            echo "Found unreleased version in NEWS." >&2; \
1737            exit 1; \
1738         fi
1739
1740 # When building a release, stricter checks should be used
1741 distcheck-release dist-release: export BUILD_RELEASE = 1
1742 distcheck-release: distcheck
1743
1744 distrebuildcheck: dist
1745         set -e; \
1746         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1747         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1748         cd $$builddir; \
1749         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1750         cd $(distdir); \
1751         ./configure; \
1752         $(MAKE) maintainer-clean; \
1753         cp $(abs_srcdir)/vcs-version .; \
1754         ./configure; \
1755         $(MAKE) $(AM_MAKEFLAGS)
1756
1757 dist-release: dist
1758         set -e; \
1759         for i in $(DIST_ARCHIVES); do \
1760           echo -n "Checking $$i ... "; \
1761           autotools/check-tar < $$i; \
1762           echo OK; \
1763         done
1764
1765 install-exec-local:
1766         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1767           "$(DESTDIR)${localstatedir}/log/ganeti" \
1768           "$(DESTDIR)${localstatedir}/run/ganeti"
1769
1770 .PHONY: apidoc
1771 if WANT_HSAPIDOC
1772 apidoc: py-apidoc hs-apidoc
1773 else
1774 apidoc: py-apidoc
1775 endif
1776
1777 .PHONY: py-apidoc
1778 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1779         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1780         $(RUN_IN_TEMPDIR) epydoc -v \
1781           --conf $(CURDIR)/epydoc.conf \
1782           --output $(CURDIR)/$(APIDOC_PY_DIR)
1783
1784 .PHONY: hs-apidoc
1785 hs-apidoc: $(HS_BUILT_SRCS)
1786         @test -n "$(HSCOLOUR)" || \
1787             { echo 'HsColour' not found during configure; exit 1; }
1788         @test -n "$(HADDOCK)" || \
1789             { echo 'haddock' not found during configure; exit 1; }
1790         rm -rf $(APIDOC_HS_DIR)/*
1791         for i in $(ALL_APIDOC_HS_DIRS); do \
1792           @mkdir_p@ $$i; \
1793         done
1794         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1795         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1796         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1797         set -e ; \
1798         cd src; \
1799         if [ "$(HS_NOCURL)" ]; \
1800         then OPTGHC="--optghc=$(HS_NOCURL)"; \
1801         else OPTGHC=""; \
1802         fi; \
1803         if [ "$(HS_PARALLEL3)" ]; \
1804         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1805         fi; \
1806         if [ "$(HS_REGEX_PCRE)" ]; \
1807         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1808         fi; \
1809         RELSRCS="$(HS_LIB_SRCS:src/%=%) $(patsubst src/%,%,$(filter src/%,$(HS_BUILT_SRCS)))"; \
1810         for file in $$RELSRCS; do \
1811           hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1812           $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1813         done ; \
1814         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1815           -t ganeti -p haddock-prologue \
1816           --source-module="%{MODULE/.//}.html" \
1817           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1818           $$OPTGHC \
1819           $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:src/%=%))
1820
1821 .PHONY: TAGS
1822 TAGS: $(GENERATED_FILES)
1823         rm -f TAGS
1824         $(GHC) -e ":etags" -v0 \
1825           $(filter-out -O -Werror,$(HFLAGS)) \
1826           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1827           $(HS_LIBTEST_SRCS)
1828         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1829           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1830           -path './qa/*.py' | \
1831           etags -l python -a -
1832
1833 .PHONY: coverage
1834 if WANT_HTOOLS
1835 coverage: py-coverage hs-coverage
1836 else
1837 coverage: py-coverage
1838 endif
1839
1840 .PHONY: py-coverage
1841 py-coverage: $(GENERATED_FILES) $(python_tests)
1842         @test -n "$(PYCOVERAGE)" || \
1843             { echo 'python-coverage' not found during configure; exit 1; }
1844         set -e; \
1845         COVERAGE=$(PYCOVERAGE) \
1846         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1847         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1848         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1849         $(PLAIN_TESTS_ENVIRONMENT) \
1850         $(abs_top_srcdir)/autotools/gen-py-coverage \
1851         $(python_tests)
1852
1853 .PHONY: hs-coverage
1854 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1855         rm -f *.tix
1856         $(MAKE) $(AM_MAKEFLAGS) hs-check
1857         @mkdir_p@ $(COVERAGE_HS_DIR)
1858         hpc sum --union $(HPCEXCL) \
1859           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1860         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1861         hpc report coverage-hs.tix
1862         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1863
1864 # Special "kind-of-QA" target for htools, needs special setup (all
1865 # tools compiled with -fhpc)
1866 .PHONY: live-test
1867 live-test: all
1868         set -e ; \
1869         cd src; \
1870         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1871         rm -f *.tix *.mix; \
1872         ./live-test.sh; \
1873         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1874           --output=live-test.tix ; \
1875         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1876         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1877           --srcdir=.. $(HPCEXCL) ; \
1878         hpc report --srcdir=.. live-test $(HPCEXCL)
1879
1880 commit-check: distcheck lint apidoc
1881
1882 .PHONY: gitignore-check
1883 gitignore-check:
1884         @if [ -n "`git status --short`" ]; then \
1885           echo "Git status is not clean!" 1>&2 ; \
1886           git status --short; \
1887           exit 1; \
1888         fi
1889
1890 # target to rebuild all man pages (both groff and html output)
1891 .PHONY: man
1892 man: $(man_MANS) $(manhtml)
1893
1894 # Target that builds all binaries (including those that are not
1895 # rebuilt except when running the tests)
1896 .PHONY: really-all
1897 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1898
1899 # we don't need the ancient implicit rules:
1900 %: %,v
1901 %: RCS/%,v
1902 %: RCS/%
1903 %: s.%
1904 %: SCCS/s.%
1905
1906 -include ./Makefile.local
1907
1908 # vim: set noet :